#property  copyright "Adeo" 
#property  link      "adeomercatus@yahoo.com"


#property indicator_separate_window
#property indicator_buffers    1
#property indicator_color1     DeepSkyBlue
//#property indicator_width1 2
#property indicator_levelcolor DimGray
#property indicator_level1     0.0

//
//
//
//
//

extern int    ShowValue      =  1;
extern int    Type           =  0;
extern double emaPeriod      = 12;
extern int    PALAreaBars    =  3;

//
//
//
//
//

double value[];
double work[][10];


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   ShowValue = MathMax(MathMin(ShowValue,9),0);
   emaPeriod = MathMax(emaPeriod,1);
      string name = "";
      switch (ShowValue)
      {   
         case 0 : name = "PAL Line";         break;
         case 1 : name = "PAL Average Line"; break;
         case 2 : name = "PAL Momentum";     break;
         case 3 : name = "PAL Area";         break;
         case 4 : name = "PAL Span";         break;
         case 5 : name = "PAL Average Span"; break;
         case 6 : name = "PAL TOW";          break;
         case 7 : name = "PAL Average TOW";  break;
         case 8 : name = "PAL Dir";          break;
         case 9 : name = "PAL Average Dir";  break;
      }         
   SetIndexBuffer(0,value); SetIndexLabel(0, name);
   // SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0,159);
   IndicatorShortName(WindowExpertName()+" "+name+" ("+ShowValue+", "+Type+", "+DoubleToStr(emaPeriod,2)+", "+PALAreaBars+")");
   return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

#define PALLine      0
#define PALaLine     1
#define PALMomentum  2
#define PALArea      3 
#define PALSpan      4 
#define PALaSpan     5
#define PALTOW       6
#define PALaTOW      7
#define PALDir       8
#define PALaDir      9

//
//
//
//
//

int start()
{
   int i,r,limit,counted_bars = IndicatorCounted();
   double emaFactor = 2.0/(1.0+emaPeriod);
      
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
            if (ArrayRange(work,0)!=Bars) ArrayResize(work,Bars);
            
            //
            //
            //
            //
            //
            
            double point = Point;
               if (Digits==3 || Digits==5) point *= 10;

   //
   //
   //
   //
   //
    
   for (i=limit, r=Bars-i-1; i >= 0; i--, r++)
   {
      if (Type==0)
      {
         double H  = iHigh(NULL,0,i);
         double PH = iHigh(NULL,0,i+1);
         double L  = iLow(NULL,0,i);
         double PL = iLow(NULL,0,i+1);
      }
      else
      {
                H  = iClose(NULL,0,i);
                PH = iClose(NULL,0,i+1);
                L  = iOpen(NULL,0,i);
                PL = iOpen(NULL,0,i+1);
      }   

      //
      //
      //
      //
      //
            
      work[r][PALLine]     = (H + L - PH - PL) / point;
      work[r][PALSpan]     = (PH - PL) / point;
      work[r][PALaLine]    = (emaFactor*(work[r][PALLine]))+((1-emaFactor)*work[r-1][PALaLine]);          
      work[r][PALaSpan]    = (emaFactor*(work[r][PALSpan]))+((1-emaFactor)*work[r-1][PALaSpan]); 
      work[r][PALArea]     = 0;
               for (int j = 0; j<PALAreaBars; j++) work[r][PALArea] += work[r-j][PALLine];
//      work[r][PALMomentum] = work[r][PALaLine] * work[r][PALSpan] * iVolume(NULL,0,i);         
      work[r][PALMomentum] = work[r][PALArea] * work[r][PALaSpan];         

      int PALSign =-1.0;
               if (MathAbs(H-PL) >= MathAbs(L-PH)) PALSign=1;
               if (PALSign==1.0)
                     if (L-PH!=0.0)
                          work[r][PALTOW] =  PALSign*(MathAbs(H-PL)/MathAbs(L-PH))/point/100.0;
                     else work[r][PALTOW] =  work[r-1][PALTOW];
               else
                     if (H-PL!=0.0)
                          work[r][PALTOW] =  PALSign*(MathAbs(L-PH)/MathAbs(H-PL))/point/100.0;
                     else work[r][PALTOW] =  work[r-1][PALTOW];
   
      work[r][PALTOW]  = MathMin(MathMax(work[r][PALTOW],-1000.0),1000.0);
      work[r][PALaTOW] = (emaFactor*(work[r][PALTOW]))+((1-emaFactor)*work[r-1][PALaTOW]);          
      
      if (MathAbs(H-PL) >= MathAbs(L-PH))
         work[r][PALDir] = (H-PL)/point;
      else work[r][PALDir] = (L-PH)/point;
      work[r][PALaDir] = (emaFactor*(work[r][PALDir]))+((1-emaFactor)*work[r-1][PALaDir]);          
      

      //
      //
      //
      //
      //
      
      switch (ShowValue)
      {   
         case 0 : value[i] = work[r][PALLine];     break;
         case 1 : value[i] = work[r][PALaLine];    break;
         case 2 : value[i] = work[r][PALMomentum]; break;
         case 3 : value[i] = work[r][PALArea];     break;
         case 4 : value[i] = work[r][PALSpan];     break;
         case 5 : value[i] = work[r][PALaSpan];    break;
         case 6 : value[i] = work[r][PALTOW];      break;
         case 7 : value[i] = work[r][PALaTOW];     break;
         case 8 : value[i] = work[r][PALDir];      break;
         case 9 : value[i] = work[r][PALaDir];
      }         
   }
   return(0);
}